? format.patch
? p4
Index: ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/ChangeLog,v
retrieving revision 1.64
diff -u -p -r1.64 ChangeLog
--- ChangeLog	1 Nov 2006 03:33:01 -0000	1.64
+++ ChangeLog	1 Nov 2006 04:17:13 -0000
@@ -1,3 +1,7 @@
+Tue Oct 31 19:55:52 2006  Ben Pfaff  <blp@gnu.org>
+
+	* Smake (GNULIB_MODULES): Add `mempcpy' module.
+
 Tue Oct 31 19:29:05 2006  Ben Pfaff  <blp@gnu.org>
 
 	* configure.ac: Drop tests for strchr, strrchr because now we
Index: Smake
===================================================================
RCS file: /cvsroot/pspp/pspp/Smake,v
retrieving revision 1.39
diff -u -p -r1.39 Smake
--- Smake	29 Oct 2006 22:09:41 -0000	1.39
+++ Smake	1 Nov 2006 04:17:13 -0000
@@ -27,6 +27,7 @@ GNULIB_MODULES = \
 	memcmp \
 	memmem \
 	memmove \
+	mempcpy \
 	memset \
 	progname \
 	readlink \
Index: src/data/ChangeLog
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/ChangeLog,v
retrieving revision 1.69
diff -u -p -r1.69 ChangeLog
--- src/data/ChangeLog	1 Nov 2006 03:36:09 -0000	1.69
+++ src/data/ChangeLog	1 Nov 2006 04:17:13 -0000
@@ -1,3 +1,33 @@
+Tue Oct 31 19:58:27 2006  Ben Pfaff  <blp@gnu.org>
+
+	* format.c: Completely rewrite, to achieve better abstraction.
+	Rewrite all references to formats in other files.
+	
+	* format.def: Rewrite and reorganize.
+
+	* settings.c: Move everything related to custom currency formats
+	into format.[ch], changing them in form, so as to group related
+	code and definitions better.  Changed all references to use the
+	new functions.
+	(static var decimal) Removed.
+	(static var grouping) Removed.
+	(static var cc) Removed.
+	(get_decimal) Removed.
+	(set_decimal) Removed.
+	(get_grouping) Removed.
+	(set_grouping) Removed.
+	(get_cc) Removed.
+	(set_cc) Removed.
+
+	* settings.h: (macro CC_CNT) Removed.
+	(macro CC_WIDTH) Removed.
+	(struct custom_currency) Removed.
+
+Tue Oct 31 19:56:19 2006  Ben Pfaff  <blp@gnu.org>
+
+	* data-in.c (data_in): Use switch statement instead of table, to
+	avoid dependence on the order of the FMT_* enums.
+
 Tue Oct 31 19:35:36 2006  Ben Pfaff  <blp@gnu.org>
 
 	* data-out.c: (num_to_string) Removed, because it was dead code.
Index: src/data/data-in.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/data-in.c,v
retrieving revision 1.15
diff -u -p -r1.15 data-in.c
--- src/data/data-in.c	1 Nov 2006 02:12:25 -0000	1.15
+++ src/data/data-in.c	1 Nov 2006 04:17:14 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -19,7 +19,7 @@
 
 #include <config.h>
 #include "data-in.h"
-#include <libpspp/message.h>
+#include <libpspp/assertion.h>
 #include <math.h>
 #include <ctype.h>
 #include <stdarg.h>
@@ -50,6 +50,7 @@ vdls_error (const struct data_in *i, con
 {
   struct msg m;
   struct string text;
+  char format_string[FMT_STRING_LEN_MAX + 1];
 
   if (i->flags & DI_IGNORE_ERROR)
     return;
@@ -59,7 +60,8 @@ vdls_error (const struct data_in *i, con
     ds_put_format (&text, _("(column %d"), i->f1);
   else
     ds_put_format (&text, _("(columns %d-%d"), i->f1, i->f2);
-  ds_put_format (&text, _(", field type %s) "), fmt_to_string (&i->format));
+  ds_put_format (&text, _(", field type %s) "),
+                 fmt_to_string (&i->format, format_string));
   ds_put_vformat (&text, format, args);
 
   m.category = MSG_DATA;
@@ -148,17 +150,9 @@ parse_numeric (struct data_in *i)
     }
   else
     sign = 1;
-  
-  if (type != FMT_DOT)
-    {
-      decimal = get_decimal();
-      grouping = get_grouping();
-    }
-  else
-    {
-      decimal = get_grouping();
-      grouping = get_decimal();
-    }
+
+  decimal = fmt_decimal_char (type);
+  grouping = fmt_grouping_char (type);
 
   i->v->f = SYSMIS;
   num = 0.0;
@@ -1342,10 +1336,8 @@ parse_MONTH (struct data_in *i)
 static void
 default_result (struct data_in *i)
 {
-  const struct fmt_desc *const fmt = &formats[i->format.type];
-
   /* Default to SYSMIS or blanks. */
-  if (fmt->cat & FCAT_STRING)
+  if (fmt_is_string (i->format.type))
     memset (i->v->s, ' ', i->format.w);
   else
     i->v->f = get_blanks();
@@ -1354,9 +1346,9 @@ default_result (struct data_in *i)
 bool
 data_in (struct data_in *i)
 {
-  const struct fmt_desc *const fmt = &formats[i->format.type];
+  bool success;
 
-  assert (check_input_specifier (&i->format, 0));
+  assert (fmt_check_input (&i->format));
 
   /* Check that we've got a string to work with. */
   if (i->e == i->s || i->format.w <= 0)
@@ -1368,15 +1360,16 @@ data_in (struct data_in *i)
   i->f2 = i->f1 + (i->e - i->s) - 1;
 
   /* Make sure that the string isn't too long. */
-  if (i->format.w > fmt->Imax_w)
+  if (i->format.w > fmt_max_input_width (i->format.type))
     {
       dls_error (i, _("Field too long (%d characters).  Truncated after "
-		   "character %d."),
-		 i->format.w, fmt->Imax_w);
-      i->format.w = fmt->Imax_w;
+                      "character %d."),
+		 i->format.w, fmt_max_input_width (i->format.type));
+      i->format.w = fmt_max_input_width (i->format.type);
     }
 
-  if (fmt->cat & FCAT_BLANKS_SYSMIS)
+  if (!(fmt_get_category (i->format.type)
+        & (FMT_CAT_STRING | FMT_CAT_BINARY | FMT_CAT_HEXADECIMAL)))
     {
       const char *cp;
 
@@ -1394,33 +1387,102 @@ data_in (struct data_in *i)
 	}
     }
   
-  {
-    typedef bool (*handler_t) (struct data_in *);
-    static const handler_t handlers[FMT_NUMBER_OF_FORMATS] = 
-      {
-	parse_numeric, parse_N, parse_numeric, parse_numeric,
-	parse_numeric, parse_numeric, parse_numeric,
-	parse_Z, parse_A, parse_AHEX, parse_IB, parse_P, parse_PIB,
-	parse_PIBHEX, parse_PK, parse_RB, parse_RBHEX,
-	NULL, NULL, NULL, NULL, NULL,
-	parse_DATE, parse_EDATE, parse_SDATE, parse_ADATE, parse_JDATE,
-	parse_QYR, parse_MOYR, parse_WKYR,
-	parse_DATETIME, parse_TIME, parse_DTIME,
-	parse_WKDAY, parse_MONTH,
-      };
 
-    handler_t handler;
-    bool success;
-
-    handler = handlers[i->format.type];
-    assert (handler != NULL);
-
-    success = handler (i);
-    if (!success)
-      default_result (i);
+  switch (i->format.type) 
+    {
+    case FMT_F:
+    case FMT_COMMA:
+    case FMT_DOT:
+    case FMT_DOLLAR:
+    case FMT_PCT:
+    case FMT_E:
+      success = parse_numeric (i);
+      break;
+    case FMT_CCA:
+    case FMT_CCB:
+    case FMT_CCC:
+    case FMT_CCD:
+    case FMT_CCE:
+      NOT_REACHED ();
+    case FMT_N:
+      success = parse_N (i);
+      break;
+    case FMT_Z:
+      success = parse_Z (i);
+      break;
+    case FMT_P:
+      success = parse_P (i);
+      break;
+    case FMT_PK:
+      success = parse_PK (i);
+      break;
+    case FMT_IB:
+      success = parse_IB (i);
+      break;
+    case FMT_PIB:
+      success = parse_PIB (i);
+      break;
+    case FMT_PIBHEX:
+      success = parse_PIBHEX (i);
+      break;
+    case FMT_RB:
+      success = parse_RB (i);
+      break;
+    case FMT_RBHEX:
+      success = parse_RBHEX (i);
+      break;
+    case FMT_DATE:
+      success = parse_DATE (i);
+      break;
+    case FMT_ADATE:
+      success = parse_ADATE (i);
+      break;
+    case FMT_EDATE:
+      success = parse_EDATE (i);
+      break;
+    case FMT_JDATE:
+      success = parse_JDATE (i);
+      break;
+    case FMT_SDATE:
+      success = parse_SDATE (i);
+      break;
+    case FMT_QYR:
+      success = parse_QYR (i);
+      break;
+    case FMT_MOYR:
+      success = parse_MOYR (i);
+      break;
+    case FMT_WKYR:
+      success = parse_WKYR (i);
+      break;
+    case FMT_DATETIME:
+      success = parse_DATETIME (i);
+      break;
+    case FMT_TIME:
+      success = parse_TIME (i);
+      break;
+    case FMT_DTIME:
+      success = parse_DTIME (i);
+      break;
+    case FMT_WKDAY:
+      success = parse_WKDAY (i);
+      break;
+    case FMT_MONTH:
+      success = parse_MONTH (i);
+      break;
+    case FMT_A:
+      success = parse_A (i);
+      break;
+    case FMT_AHEX:
+      success = parse_AHEX (i);
+      break;
+    default:
+      NOT_REACHED ();
+    }
+  if (!success)
+    default_result (i);
 
-    return success;
-  }
+  return success;
 }
 
 /* Utility function. */
Index: src/data/data-out.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/data-out.c,v
retrieving revision 1.8
diff -u -p -r1.8 data-out.c
--- src/data/data-out.c	1 Nov 2006 03:36:10 -0000	1.8
+++ src/data/data-out.c	1 Nov 2006 04:17:15 -0000
@@ -1,5 +1,5 @@
 /* PSPP - computes sample statistics.
-   Copyright (C) 1997-9, 2000 Free Software Foundation, Inc.
+   Copyright (C) 1997-9, 2000, 2006 Free Software Foundation, Inc.
    Written by Ben Pfaff <blp@gnu.org>.
 
    This program is free software; you can redistribute it and/or
@@ -58,17 +58,17 @@ static string_converter convert_A, conve
 bool
 data_out (char *s, const struct fmt_spec *fp, const union value *v)
 {
-  int cat = formats[fp->type].cat;
   int ok;
 
-  assert (check_output_specifier (fp, 0));
-  if (!(cat & FCAT_STRING)) 
+  assert (fmt_check_output (fp));
+  if (fmt_is_numeric (fp->type)) 
     {
-      /* Numeric formatting. */
+      enum fmt_category category = fmt_get_category (fp->type);
       double number = v->f;
 
       /* Handle SYSMIS turning into blanks. */
-      if ((cat & FCAT_BLANKS_SYSMIS) && number == SYSMIS)
+      if (!(category & (FMT_CAT_CUSTOM | FMT_CAT_BINARY | FMT_CAT_HEXADECIMAL))
+          && number == SYSMIS)
         {
           memset (s, ' ', fp->w);
           s[fp->w - fp->d - 1] = '.';
@@ -76,7 +76,9 @@ data_out (char *s, const struct fmt_spec
         }
 
       /* Handle decimal shift. */
-      if ((cat & FCAT_SHIFT_DECIMAL) && number != SYSMIS && fp->d)
+      if ((category & (FMT_CAT_LEGACY | FMT_CAT_BINARY))
+          && number != SYSMIS
+          && fp->d)
         number *= pow (10.0, fp->d);
 
       switch (fp->type) 
@@ -310,12 +312,11 @@ convert_E (char *dst, const struct fmt_s
 
   /* The C locale always uses a period `.' as a decimal point.
      Translate to comma if necessary. */
-  if ((get_decimal() == ',' && fp->type != FMT_DOT)
-      || (get_decimal() == '.' && fp->type == FMT_DOT))
+  if (fmt_decimal_char (fp->type) != '.')
     {
       char *cp = strchr (buf, '.');
       if (cp)
-	*cp = ',';
+	*cp = fmt_decimal_char (fp->type);
     }
 
   memcpy (dst, buf, fp->w);
@@ -925,7 +926,7 @@ insert_commas (char *dst, const char *sr
       if (i % 3 == 0 && n_digits > i && n_items > n_reserved)
 	{
 	  n_items--;
-	  *dst++ = fp->type == FMT_COMMA ? get_grouping() : get_decimal();
+	  *dst++ = fmt_grouping_char (fp->type);
 	}
       *dst++ = *sp++;
     }
@@ -951,7 +952,7 @@ year4 (int year)
 static int
 try_CCx (char *dst, const struct fmt_spec *fp, double number)
 {
-  const struct custom_currency *cc = get_cc(fp->type - FMT_CCA);
+  const struct fmt_number_style *style = fmt_get_style (fp->type);
 
   struct fmt_spec f;
 
@@ -961,10 +962,10 @@ try_CCx (char *dst, const struct fmt_spe
 
   /* Determine length available, decimal character for number
      proper. */
-  f.type = cc->decimal == get_decimal () ? FMT_COMMA : FMT_DOT;
-  f.w = fp->w - strlen (cc->prefix) - strlen (cc->suffix);
+  f.type = style->decimal == fmt_decimal_char (FMT_COMMA) ? FMT_COMMA : FMT_DOT;
+  f.w = fp->w - fmt_affix_width (style);
   if (number < 0)
-    f.w -= strlen (cc->neg_prefix) + strlen (cc->neg_suffix) - 1;
+    f.w -= fmt_neg_affix_width (style) - 1;
   else
     /* Convert -0 to +0. */
     number = fabs (number);
@@ -982,8 +983,9 @@ try_CCx (char *dst, const struct fmt_spe
   /* Postprocess back into buf. */
   cp = buf;
   if (number < 0)
-    cp = stpcpy (cp, cc->neg_prefix);
-  cp = stpcpy (cp, cc->prefix);
+    cp = mempcpy (cp, ss_data (style->neg_prefix),
+                  ss_length (style->neg_prefix));
+  cp = mempcpy (cp, ss_data (style->prefix), ss_length (style->prefix));
   {
     char *bp = buf2;
     while (*bp == ' ')
@@ -996,9 +998,10 @@ try_CCx (char *dst, const struct fmt_spe
     memcpy (cp, bp, f.w - (bp - buf2));
     cp += f.w - (bp - buf2);
   }
-  cp = stpcpy (cp, cc->suffix);
+  cp = mempcpy (cp, ss_data (style->suffix), ss_length (style->suffix));
   if (number < 0)
-    cp = stpcpy (cp, cc->neg_suffix);
+    cp = mempcpy (cp, ss_data (style->neg_suffix),
+                  ss_length (style->neg_suffix));
 
   /* Copy into dst. */
   assert (cp - buf <= fp->w);
Index: src/data/dictionary.c
===================================================================
RCS file: /cvsroot/pspp/pspp/src/data/dictionary.c,v
retrieving revision 1.17
diff -u -p -r1.17 dictionary.c
--- src/data/dictionary.c	29 Oct 2006 09:51:35 -0000	1.17
+++ src/data/dictionary.c	1 Nov 2006 04:17:16 -0000
@@ -287,14 +287,14 @@ dict_create_var (struct dictionary *d, c
   mv_init (&v->miss, width);
   if (v->type == NUMERIC)
     {
-      v->print = f8_2;
+      v->print = fmt_for_output (FMT_F, 8, 2);
       v->alignment = ALIGN_RIGHT;
       v->display_width = 8;
       v->measure = MEASURE_SCALE;
     }
   else
     {
-      v->print = make_output_format (FMT_A, v->width, 0);
+      v->print = fmt_for_output (FMT_A, v->width, 0);
       v->alignment = ALIGN_LEFT;
       v->display_width = 8;
       v->measure = MEASURE_NOMINAL;
